//-------------------------------------------------------------------
// ACD.h
//-------------------------------------------------------------------
// ACD SYSTEMS INTERNATIONAL INC.
// Copyright © 1994 - 2020 ACD Systems International Inc.
// All Rights Reserved
//
// NOTICE: ACD Systems International Inc. ("ACD") permits you to use,
// modify, and distribute this file in accordance with the terms of
// the ACDSee SDK license agreement accompanying it. If you have 
// received this file from a source other than ACD, then your use,
// modification, or distribution of it requires the prior written 
// permission of ACD.
//-------------------------------------------------------------------
#pragma once

enum
{
   ACD_RPP     = 1,  // xml string of multiple values
   ACD_CAPTION,
   ACD_DATE,         // string value stored in XMP Date format
   ACD_AUTHOR,
   ACD_RATING,       // string value of number
   ACD_TAGGED,       // string XMP Boolean value ("True" or "False")
   ACD_NOTES,
   ACD_KEYWORDS,     // list of strings
   ACD_CATEGORIES,   // xml string of multiple values
   ACD_IMAGE_EDITED, // string XMP Boolean value ("True" or "False")
   ACD_RAWRPPUSED,    // string XMP Boolean value ("True" or "False")
   ACD_GPSLATITUDEEXIST, // string XMP Boolean value ("True" or "False")
   ACD_GPSLONGITUDEEXIST, // string XMP Boolean value ("True" or "False")
   ACD_LABEL,//// string value
   ACD_COLLECTIONS,   // xml string of multiple values
   ACD_SNAPSHOTS,// additional develop settings saved in RPP,
   ACD_REGIONS,
   //ACD_REGIONS subIDs
   
   //keep together 
   ACD_REGIONS_APPLIEDTODIMENSION, 
   ACD_REGIONS_REGIONLIST,
   
   ACD_REGIONS_APPLIEDTODIMENSION_H,
   ACD_REGIONS_APPLIEDTODIMENSION_UNIT,
   ACD_REGIONS_APPLIEDTODIMENSION_W,
   
   ACD_REGIONS_REGIONLIST_DLYAREA,
   ACD_REGIONS_REGIONLIST_ALGAREA,
   ACD_REGIONS_REGIONLIST_NAME,
   ACD_REGIONS_REGIONLIST_TYPE,
   ACD_REGIONS_REGIONLIST_DLYROTATION,
   ACD_REGIONS_REGIONLIST_ALGROTATION,
   ACD_REGIONS_REGIONLIST_NAMEASSIGNTYPE,
   ACD_REGIONS_REGIONLIST_PAGENUM,
   ACD_REGIONS_REGIONLIST_DISTANCE,
 
   ACD_REGIONS_REGIONLIST_AREA_H,
   ACD_REGIONS_REGIONLIST_AREA_W,
   ACD_REGIONS_REGIONLIST_AREA_X,
   ACD_REGIONS_REGIONLIST_AREA_Y,
};

struct ACD_Item
{
   DWORD       nDataID;
   int         nCount;
   union
   {
      // all data, regardless of real type is stored as a string or array of strings
      // Note: strings are all utf8 encoded
      char*    pszData;
      char**   ppszData;  
   };

   ACD_Item*  pNext;
};
