//-------------------------------------------------------------------
// Embedded.h
//-------------------------------------------------------------------
// ACD SYSTEMS INTERNATIONAL INC.
// Copyright © 1994 - 2020 ACD Systems International Inc.
// All Rights Reserved
//
// NOTICE: ACD Systems International Inc. ("ACD") permits you to use,
// modify, and distribute this file in accordance with the terms of
// the ACDSee SDK license agreement accompanying it. If you have 
// received this file from a source other than ACD, then your use,
// modification, or distribution of it requires the prior written 
// permission of ACD.
//-------------------------------------------------------------------

#include <windows.h>
#include <initguid.h>

#ifndef _EMBEDDED_H_INCLUDED
#define _EMBEDDED_H_INCLUDED

typedef int (__stdcall *PF_GENERIC)();

/////////////
// ED_Item //
/////////////
struct ED_Item
{
	ED_Item() { ZeroMemory(this, sizeof(*this)); }

	GUID	guidTag;
	DWORD	dwType;
	DWORD   cbSize;

	union
	{
		BYTE				bData;
		WORD				wData;
		DWORD 				dwData;
		void*				pData;
		char*				pszData;
		double  			flData;
		PF_GENERIC         	fnData;
	};
	ED_Item* pNext;
};

//////////////////////
// Data Type Values //
//////////////////////
enum
{
	EDT_BYTE		= 1,
	EDT_WORD		= 2,
	EDT_DWORD		= 3,
	EDT_UNDEFINED	= 4,
	EDT_STRING		= 5,
	EDT_DOUBLE		= 6,
	EDT_FUNCTION	= 7,
};

////////////////////////////////////////////
// GUIDs for known types of embedded data //
////////////////////////////////////////////

// EDT_ALLOCATE {1FF6004C-D1D7-48e0-81C3-BC3812BDD7D0}
DEFINE_GUID(EDT_ALLOCATE,   0x1ff6004c, 0xd1d7, 0x48e0, 0x81, 0xc3, 0xbc, 0x38, 0x12, 0xbd, 0xd7, 0xd0);

// EDT_DEALLOCATE {6C70B295-92DA-43d3-A0DD-7DE5B0269840}
DEFINE_GUID(EDT_DEALLOCATE, 0x6c70b295, 0x92da, 0x43d3, 0xa0, 0xdd, 0x7d, 0xe5, 0xb0, 0x26, 0x98, 0x40);

// EDT_THUMBNAIL {3623C12E-6FDE-4a8f-AC96-4171BE568D11}
DEFINE_GUID(EDT_THUMBNAIL,  0x3623c12e, 0x6fde, 0x4a8f, 0xac, 0x96, 0x41, 0x71, 0xbe, 0x56, 0x8d, 0x11);

// EDT_MAKEROFFSET {2C86A9EB-F96E-462c-B207-64C2B577158B}
DEFINE_GUID(EDT_MAKEROFFSET, 0x2c86a9eb, 0xf96e, 0x462c, 0xb2, 0x7, 0x64, 0xc2, 0xb5, 0x77, 0x15, 0x8b);

#endif
