//-------------------------------------------------------------------
// IPTC.h
//-------------------------------------------------------------------
// ACD SYSTEMS INTERNATIONAL INC.
// Copyright © 1994 - 2020 ACD Systems International Inc.
// All Rights Reserved
//
// NOTICE: ACD Systems International Inc. ("ACD") permits you to use,
// modify, and distribute this file in accordance with the terms of
// the ACDSee SDK license agreement accompanying it. If you have 
// received this file from a source other than ACD, then your use,
// modification, or distribution of it requires the prior written 
// permission of ACD.
//-------------------------------------------------------------------
#pragma once

//string are encoded in UTF-8
struct IPTC_Item
{
   DWORD       nDataID;
   int         nCount;
   union
   {
      char*    pszData;
      char**   ppszData;  
   };

   IPTC_Item*  pNext;
};

#define IPTC_CORE_ID_BASE       99
enum
{
   IPTC_CODEDCHARACTERSET		 = MAKELONG(1,90),
   IPTC_OBJECTNAME               = MAKELONG(2,5),
   IPTC_EDITSTATUS               = MAKELONG(2,7),
   IPTC_URGENCY                  = MAKELONG(2,10),
   IPTC_CATEGORY                 = MAKELONG(2,15),
   IPTC_SUPPLEMENTALCATEGORIES   = MAKELONG(2,20),
   IPTC_FIXTUREINDENTIFIER       = MAKELONG(2,22),
   IPTC_KEYWORDS                 = MAKELONG(2,25),
   IPTC_RELEASEDATE              = MAKELONG(2,30),
   IPTC_RELEASETIME              = MAKELONG(2,35),
   IPTC_SPECIALINSTRUCTIONS      = MAKELONG(2,40),
   IPTC_DATECREATED              = MAKELONG(2,55),
   IPTC_TIMECREATED              = MAKELONG(2,60),
   IPTC_DIGITALCREATIONDATE      = MAKELONG(2,62),
   IPTC_DIGITALCREATIONTIME      = MAKELONG(2,63),
   IPTC_ORIGINATINGPROGRAM       = MAKELONG(2,65),
   IPTC_OBJECTCYCLE              = MAKELONG(2,75),
   IPTC_BYLINE                   = MAKELONG(2,80),
   IPTC_BYLINETITLE              = MAKELONG(2,85),
   IPTC_CITY                     = MAKELONG(2,90),
   IPTC_SUBLOCATION              = MAKELONG(2,92),
   IPTC_PROVICESTATE             = MAKELONG(2,95),
   IPTC_PRIMARYCODELOCATION      = MAKELONG(2,100),
   IPTC_PRIMARYLOCATIONNAME      = MAKELONG(2,101),
   IPTC_TRANSMISSIONREFERNCE     = MAKELONG(2,103),
   IPTC_HEADLINE                 = MAKELONG(2,105),
   IPTC_CREDIT                   = MAKELONG(2,110),
   IPTC_SOURCE                   = MAKELONG(2,115),
   IPTC_COPYRIGHTNOTICE          = MAKELONG(2,116),
   IPTC_CAPTIONABSTRACT          = MAKELONG(2,120),
   IPTC_WRITEREDITOR             = MAKELONG(2,122),

   IPTC_INTELLECTUALGENRE        = MAKELONG(2,4),
   IPTC_SUBJECTCODE              = MAKELONG(2,12),

   //IPTC Core only which no mapping to IIM
   IPTC_SCENECODE                = MAKELONG(IPTC_CORE_ID_BASE,1),
   IPTC_USAGETERMS               = MAKELONG(IPTC_CORE_ID_BASE,2),
   IPTC_CREATORCONTACTINFO_ADDRESS         = MAKELONG(IPTC_CORE_ID_BASE,3),
   IPTC_CREATORCONTACTINFO_CITY            = MAKELONG(IPTC_CORE_ID_BASE,4),
   IPTC_CREATORCONTACTINFO_COUNTRY         = MAKELONG(IPTC_CORE_ID_BASE,5),
   IPTC_CREATORCONTACTINFO_EMAILADDRESS    = MAKELONG(IPTC_CORE_ID_BASE,6),
   IPTC_CREATORCONTACTINFO_PHONENUMBERS    = MAKELONG(IPTC_CORE_ID_BASE,7),
   IPTC_CREATORCONTACTINFO_POSTALCODE      = MAKELONG(IPTC_CORE_ID_BASE,8),
   IPTC_CREATORCONTACTINFO_STATEPROVINCE   = MAKELONG(IPTC_CORE_ID_BASE,9),
   IPTC_CREATORCONTACTINFO_WEBURLS         = MAKELONG(IPTC_CORE_ID_BASE,10),
};

enum
{
   IPTC_DIGEST_MISSING = -1,
   IPTC_DIGEST_MATCH = 0,
   IPTC_DIGEST_DIFFER = 1,
};